<template>
  <div class="h-[588px]">
    <h2 class="text-2xl font-bold mb-6 mt-10 --text2">{{ $t('bk8_hot_games_title') }}</h2>
    <div class="flex items-center justify-between game-filter game-filter-bg">
      <div class="flex items-center">
        <div
          class="cursor-pointer game-tab-menu"
          :class="{ 'active-tab': tab === tabMenu[0].Type }"
          @click="onFilter(tabMenu[0])"
        >
          <div
            class="items-center px-4 mt-1 py-3 w-fit el-tooltip__trigger el-tooltip__trigger"
          >
            <div class="flex items-center justify-center">
              <img
                class="mr-2.5"
                :src="getAssetImage('assets/theme/common/icon/top_games.png')"
              /><span class="whitespace-nowrap fc-text font-bold">{{
                $t("hot_games")
              }}</span>
            </div>
          </div>
        </div>
        <div
          class="cursor-pointer game-tab-menu"
          :class="{ 'active-tab': tab === tabMenu[1].Type }"
          @click="onFilter(tabMenu[1])"
        >
          <div
            class="items-center px-4 mt-1 py-3 w-fit el-tooltip__trigger el-tooltip__trigger"
          >
            <div class="flex items-center justify-center">
              <img
                class="mr-2.5"
                :src="getAssetImage('assets/theme/common/icon/new_games.png')"
              /><span class="whitespace-nowrap fc-text font-bold">{{
                $t("new_games")
              }}</span>
            </div>
          </div>
        </div>
      </div>
      <div class="pr-[16px]">
        <nuxt-link :to="redirect" class="text-[var(--secondary)] font-[700]"
          >{{ $t("more_games")
          }}<font-awesome-icon class="ml-3" icon="arrow-right-long"
        /></nuxt-link>
      </div>
    </div>
    <div class="mt-6 text-xs">
      <lobby-render
        :loading="isLoading"
        :games="games"
        :is-has-group-title="false"
        :gap="6"
        class-game-name="text-white"
        :show-staus="true"
        :is-has-load-more="isHasLoadMore"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, PropType, ref, onMounted } from "vue";
import { useGameEntryComponent } from "@/composables/useTheme";
import { IGameEntryMenu } from "@/models/gameEntryFilter";
import { GameBsi, GameFilterRequest } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { gameStore } from "~~/store/game";

export default defineComponent({
  props: {
    menus: {
      type: Object as PropType<IGameEntryMenu>,
    },
    isHasLoadMore: {
      type: Boolean,
      default: true,
    },
  },
  setup() {
    const {
      isLoading,
      getHotGameListInitial,
      getNewGameListInitial,
      initialedGame,
    } = useGameEntryComponent();
    const { getAssetImage } = commonHelper;
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const initalGame = computed(
      (): Array<GameBsi> => initialedGame.value.map((item) => new GameBsi(item))
    );
    const topGames = computed(
      (): Array<GameBsi> =>
        initalGame.value.filter((isTopGame) => isTopGame.IsHotGame)
    );
    const newGames = computed(
      (): Array<GameBsi> =>
        initalGame.value.filter((isNewGame) => isNewGame.IsNewGame)
    );
    const games = ref<Array<GameBsi>>([]);
    const tabMenu: Array<GameFilterRequest> = [
      {
        Type: "Top Games",
        Value: "main",
      },
      {
        Type: "New Games",
        Value: "main",
      },
    ];
    const tab = ref(tabMenu[0].Type);
    const redirect = ref("/games");
    const onFilter = async (request: GameFilterRequest) => {
      const isTopGame = request.Type === "Top Games";
      // games.value = isTopGame ? topGames.value : newGames.value;
      if (isTopGame) await getHotGameListInitial();
      else await getNewGameListInitial();
      games.value = initalGame.value.slice(0, 12);
      tab.value = request.Type;
      redirect.value = isTopGame
        ? "/games?f=Hot Games"
        : `/games?f=${tab.value}`;
    };
    onMounted(() => onFilter(tabMenu[0]));
    return {
      isLoading,
      games,
      onFilter,
      tabMenu,
      tab,
      getAssetImage,
      redirect,
    };
  },
});
</script>

<style lang="scss">
:root {
  --gf-background-color: var(--primary);
  --gf-text-color: var(--textBtn);
  --gf-text-active-color: rgb(93, 240, 244);
  --game-tab-img-size: 20px;
  --tab-font-size: 14px;
  --tab-item-width: 100px;
}

.game-filter-bg {
  background: var(--background1) !important;
}

.whitespace-nowrap {
  color: var(--text);
  margin-left: 5px;
}

.message-count {
  .whitespace-nowrap {
    margin-left: 0;
  }
}

.game-tab-menu {
  position: relative;
  color: var(--gf-text-color);
  height: 56px;

  img {
    filter: brightness(0) saturate(100%) invert(56%) sepia(10%) saturate(738%)
      hue-rotate(198deg) brightness(0%) contrast(84%);
    width: var(--game-tab-img-size);
    height: var(--game-tab-img-size);
  }

  span {
    font-size: var(--tab-font-size);
  }
}

.game-tab-menu:hover,
.active-tab {
  background: var(--secondary);

  img {
    filter: brightness(0) saturate(100%) invert(100%) sepia(4%) saturate(626%)
      hue-rotate(245deg) brightness(121%) contrast(100%);
  }
  
  span {
    color: var(--textBtn);
  }

  .game-drop-down {
    display: block;
  }
}
</style>
